from collections.abc import Awaitable, Callable, Sequence
from typing import Any

from temporalio import workflow

from csirtmu.beta_temporal.commons.actions import RTCommonActions
from csirtmu.beta_temporal.commons.actions.temporal_common_actions import TemporalCommonActions
from csirtmu.beta_temporal.commons.conditions import CommonConditions
from csirtmu.beta_temporal.config import AppConfig
from csirtmu.beta_temporal.external_services.rt.client import RTClient
from csirtmu.beta_temporal.external_services.rt.structs import TransactionStruct
from csirtmu.beta_temporal.workflows.logging import LoggedWorkflow


class SetStatusActOnEmailCorrespondWorkflow(LoggedWorkflow):
    @classmethod
    def get_activities(cls) -> Sequence[Callable[..., Awaitable[Any]]]:
        config = AppConfig.get()
        rt_client = RTClient(config.rt)
        conditions = CommonConditions(rt_client)
        rt_actions = RTCommonActions(rt_client)
        temporal_actions = TemporalCommonActions(config.temporal)
        return [*conditions.get_activities(), *rt_actions.get_activities(), *temporal_actions.get_activities()]

    @workflow.run
    async def run(self, transaction: TransactionStruct) -> None:
        self.log_workflow()
        config = AppConfig.get()
        if await workflow.execute_activity(
            CommonConditions.is_from_interface,
            args=(
                "Email",
                transaction,
            ),
            retry_policy=config.temporal.retry_policy,
            start_to_close_timeout=config.temporal.activity_timeout,
        ):
            await workflow.execute_activity(
                RTCommonActions.set_ticket_status,
                args=(
                    "Act",
                    transaction,
                    False,
                ),
                retry_policy=config.temporal.retry_policy,
                start_to_close_timeout=config.temporal.activity_timeout,
            )
        elif config.temporal.allow_internal_cancels:
            await workflow.execute_activity(
                TemporalCommonActions.cancel_workflow,
                args=(
                    workflow.info().workflow_id,
                    workflow.info().task_queue,
                ),
                retry_policy=config.temporal.retry_policy,
                start_to_close_timeout=config.temporal.activity_timeout,
            )
